hOpenPGP-0.14: native Haskell implementation of OpenPGP (RFC4880)

Safe Haskell | None

Codec.Encryption.OpenPGP.Types

# Documentation

type TimeStamp = Word32 Source

type Exportability = Bool Source

type TrustLevel = Word8 Source

type TrustAmount = Word8 Source

type AlmostPublicDomainRegex = ByteString Source

type Revocability = Bool Source

type RevocationReason = ByteString Source

type KeyServer = ByteString Source

type URL = ByteString Source

type NotationName = ByteString Source

type NotationValue = ByteString Source

type SignatureHash = ByteString Source

type PacketVersion = Word8 Source

type Salt = ByteString Source

type Count = Int Source

type V3Expiration = Word16 Source

type CompressedDataPayload = ByteString Source

type FileName = ByteString Source

type ImageData = ByteString Source

type NestedFlag = Bool Source

type IV = ByteString Source

data SymmetricAlgorithm Source

Constructors

Plaintext |
IDEA |
TripleDES |
CAST5 |
Blowfish |
ReservedSAFER |
ReservedDES |
AES128 |
AES192 |
AES256 |
Twofish |
OtherSA Word8 |

Instances

Eq SymmetricAlgorithm |
Data SymmetricAlgorithm |
Ord SymmetricAlgorithm |
Show SymmetricAlgorithm |
Typeable SymmetricAlgorithm |
Serialize SymmetricAlgorithm |
FutureVal SymmetricAlgorithm |

data NotationFlag Source

Constructors

HumanReadable |
OtherNF Int |

Instances

Eq NotationFlag |
Data NotationFlag |
Ord NotationFlag |
Show NotationFlag |
Typeable NotationFlag |
FutureFlag NotationFlag |

data SigSubPacket Source

Constructors

SigSubPacket |

Fields

_sspCriticality :: Bool
_sspPayload :: SigSubPacketPayload

Instances

Eq SigSubPacket |
Data SigSubPacket |
Show SigSubPacket |
Typeable SigSubPacket |
Serialize SigSubPacket |

data SigSubPacketPayload Source

Constructors

SigCreationTime TimeStamp |
SigExpirationTime TimeStamp |
ExportableCertification Exportability |
TrustSignature TrustLevel TrustAmount |
RegularExpression AlmostPublicDomainRegex |
Revocable Revocability |
KeyExpirationTime TimeStamp |
PreferredSymmetricAlgorithms [SymmetricAlgorithm] |
RevocationKey (Set RevocationClass) PubKeyAlgorithm TwentyOctetFingerprint |
Issuer EightOctetKeyId |
NotationData (Set NotationFlag) NotationName NotationValue |
PreferredHashAlgorithms [HashAlgorithm] |
PreferredCompressionAlgorithms [CompressionAlgorithm] |
KeyServerPreferences (Set KSPFlag) |
PreferredKeyServer KeyServer |
PrimaryUserId Bool |
PolicyURL URL |
KeyFlags (Set KeyFlag) |
SignersUserId String |
ReasonForRevocation RevocationCode RevocationReason |
Features (Set FeatureFlag) |
SignatureTarget PubKeyAlgorithm HashAlgorithm SignatureHash |
EmbeddedSignature SignaturePayload |
UserDefinedSigSub Word8 ByteString |
OtherSigSub Word8 ByteString |

Instances

Eq SigSubPacketPayload |
Data SigSubPacketPayload |
Show SigSubPacketPayload |
Typeable SigSubPacketPayload |

data HashAlgorithm Source

Constructors

DeprecatedMD5 |
SHA1 |
RIPEMD160 |
SHA256 |
SHA384 |
SHA512 |
SHA224 |
OtherHA Word8 |

Instances

Eq HashAlgorithm |
Data HashAlgorithm |
Ord HashAlgorithm |
Show HashAlgorithm |
Typeable HashAlgorithm |
Serialize HashAlgorithm |
FutureVal HashAlgorithm |

data CompressionAlgorithm Source

Constructors

Uncompressed |
ZIP |
ZLIB |
BZip2 |
OtherCA Word8 |

Instances

Eq CompressionAlgorithm |
Data CompressionAlgorithm |
Ord CompressionAlgorithm |
Show CompressionAlgorithm |
Typeable CompressionAlgorithm |
Serialize CompressionAlgorithm |
FutureVal CompressionAlgorithm |

class (Eq a, Ord a) => FutureVal a where Source

Methods

fromFVal :: a -> Word8 Source

toFVal :: Word8 -> aSource

Instances

FutureVal SigType |
FutureVal ImageFormat |
FutureVal DataType |
FutureVal RevocationCode |
FutureVal PubKeyAlgorithm |
FutureVal CompressionAlgorithm |
FutureVal HashAlgorithm |
FutureVal SymmetricAlgorithm |

data PubKeyAlgorithm Source

Constructors

RSA |
DeprecatedRSAEncryptOnly |
DeprecatedRSASignOnly |
ElgamalEncryptOnly |
DSA |
EC |
ECDSA |
ForbiddenElgamal |
DH |
OtherPKA Word8 |

Instances

Eq PubKeyAlgorithm |
Data PubKeyAlgorithm |
Ord PubKeyAlgorithm |
Show PubKeyAlgorithm |
Typeable PubKeyAlgorithm |
Serialize PubKeyAlgorithm |
FutureVal PubKeyAlgorithm |

class (Eq a, Ord a) => FutureFlag a where Source

Methods

fromFFlag :: a -> Int Source

toFFlag :: Int -> aSource

Instances

FutureFlag FeatureFlag |
FutureFlag RevocationClass |
FutureFlag KeyFlag |
FutureFlag KSPFlag |
FutureFlag NotationFlag |

data KSPFlag Source

Constructors

NoModify |
KSPOther Int |

Instances

Eq KSPFlag |
Data KSPFlag |
Ord KSPFlag |
Show KSPFlag |
Typeable KSPFlag |
FutureFlag KSPFlag |

data KeyFlag Source

Constructors

GroupKey |
AuthKey |
SplitKey |
EncryptStorageKey |
EncryptCommunicationsKey |
SignDataKey |
CertifyKeysKey |
KFOther Int |

Instances

Eq KeyFlag |
Data KeyFlag |
Ord KeyFlag |
Show KeyFlag |
Typeable KeyFlag |
FutureFlag KeyFlag |

data RevocationClass Source

Constructors

SensitiveRK |
RClOther Int |

Instances

Eq RevocationClass |
Data RevocationClass |
Ord RevocationClass |
Show RevocationClass |
Typeable RevocationClass |
FutureFlag RevocationClass |

data RevocationCode Source

Constructors

NoReason |
KeySuperseded |
KeyMaterialCompromised |
KeyRetiredAndNoLongerUsed |
UserIdInfoNoLongerValid |
RCoOther Word8 |

Instances

Eq RevocationCode |
Data RevocationCode |
Ord RevocationCode |
Show RevocationCode |
Typeable RevocationCode |
FutureVal RevocationCode |

data FeatureFlag Source

Constructors

ModificationDetection |
FeatureOther Int |

Instances

Eq FeatureFlag |
Data FeatureFlag |
Ord FeatureFlag |
Show FeatureFlag |
Typeable FeatureFlag |
FutureFlag FeatureFlag |

newtype MPI Source

Constructors

MPI |

Fields

unMPI :: Integer

Instances

Eq MPI |
Data MPI |
Show MPI |
Typeable MPI |
Serialize MPI |

data SignaturePayload Source

Constructors

SigV3 SigType Word32 EightOctetKeyId PubKeyAlgorithm HashAlgorithm Word16 [MPI] |
SigV4 SigType PubKeyAlgorithm HashAlgorithm [SigSubPacket] [SigSubPacket] Word16 [MPI] |
SigVOther Word8 ByteString |

Instances

Eq SignaturePayload |
Data SignaturePayload |
Show SignaturePayload |
Typeable SignaturePayload |
Serialize SignaturePayload |

data KeyVersion Source

Constructors

DeprecatedV3 |
V4 |

Instances

Eq KeyVersion |
Data KeyVersion |
Ord KeyVersion |
Show KeyVersion |
Typeable KeyVersion |

data PKPayload Source

Constructors

PKPayload |

Fields

_keyVersion :: KeyVersion
_timestamp :: TimeStamp
_v3exp :: V3Expiration
_pkalgo :: PubKeyAlgorithm
_pubkey :: PKey

Instances

Eq PKPayload |
Data PKPayload |
Ord PKPayload |
Show PKPayload |
Typeable PKPayload |
Serialize PKPayload |

data SKAddendum Source

Constructors

SUS16bit SymmetricAlgorithm S2K IV ByteString |
SUSSHA1 SymmetricAlgorithm S2K IV ByteString |
SUSym SymmetricAlgorithm IV ByteString |
SUUnencrypted SKey Word16 |

Instances

Eq SKAddendum |
Data SKAddendum |
Show SKAddendum |
Typeable SKAddendum |

data DataType Source

Constructors

BinaryData |
TextData |
UTF8Data |
OtherData Word8 |

Instances

Eq DataType |
Data DataType |
Ord DataType |
Show DataType |
Typeable DataType |
FutureVal DataType |

data S2K Source

Constructors

Simple HashAlgorithm |
Salted HashAlgorithm Salt |
IteratedSalted HashAlgorithm Salt Count |
OtherS2K Word8 ByteString |

Instances

Eq S2K |
Data S2K |
Show S2K |
Typeable S2K |
Serialize S2K |

data UserAttrSubPacket Source

Constructors

ImageAttribute ImageHeader ImageData |
OtherUASub Word8 ByteString |

Instances

Eq UserAttrSubPacket |
Data UserAttrSubPacket |
Show UserAttrSubPacket |
Typeable UserAttrSubPacket |
Serialize UserAttrSubPacket |

data ImageHeader Source

Constructors

ImageHV1 ImageFormat |

Instances

Eq ImageHeader |
Data ImageHeader |
Show ImageHeader |
Typeable ImageHeader |

data ImageFormat Source

Constructors

JPEG |
OtherImage Word8 |

Instances

Eq ImageFormat |
Data ImageFormat |
Ord ImageFormat |
Show ImageFormat |
Typeable ImageFormat |
FutureVal ImageFormat |

data SigType Source

Constructors

BinarySig |
CanonicalTextSig |
StandaloneSig |
GenericCert |
PersonaCert |
CasualCert |
PositiveCert |
SubkeyBindingSig |
PrimaryKeyBindingSig |
SignatureDirectlyOnAKey |
KeyRevocationSig |
SubkeyRevocationSig |
CertRevocationSig |
TimestampSig |
ThirdPartyConfirmationSig |
OtherSig Word8 |

Instances

Eq SigType |
Data SigType |
Ord SigType |
Show SigType |
Typeable SigType |
Serialize SigType |
FutureVal SigType |

data PKey Source

Constructors

RSAPubKey PublicKey |
DSAPubKey PublicKey |
ElGamalPubKey [Integer] |
UnknownPKey ByteString |

Instances

Eq PKey |
Data PKey |
Ord PKey |
Show PKey |
Typeable PKey |

data SKey Source

Constructors

RSAPrivateKey PrivateKey |
DSAPrivateKey PrivateKey |
ElGamalPrivateKey [Integer] |
UnknownSKey ByteString |

Instances

Eq SKey |
Data SKey |
Show SKey |
Typeable SKey |

newtype Block a Source

Constructors

Block |

Fields

unBlock :: [a]

Instances

Eq a => Eq (Block a) |
Show a => Show (Block a) |
Serialize a => Serialize (Block a) |

newtype EightOctetKeyId Source

Constructors

EightOctetKeyId |

Fields

unEOKI :: ByteString

Instances

Eq EightOctetKeyId |
Data EightOctetKeyId |
Ord EightOctetKeyId |
Read EightOctetKeyId |
Show EightOctetKeyId |
Typeable EightOctetKeyId |

newtype TwentyOctetFingerprint Source

Constructors

TwentyOctetFingerprint |

Fields

unTOF :: ByteString

Instances

Eq TwentyOctetFingerprint |
Data TwentyOctetFingerprint |
Ord TwentyOctetFingerprint |
Read TwentyOctetFingerprint |
Show TwentyOctetFingerprint |
Typeable TwentyOctetFingerprint |

w8sToHex :: [Word8] -> String Source

hexToW8s :: ReadS Word8 Source

data TK Source

Constructors

TK |

Fields

_tkPKP :: PKPayload
_tkmSKA :: Maybe SKAddendum
_tkRevs :: [SignaturePayload]
_tkUIDs :: [(String, [SignaturePayload])]
_tkUAts :: [([UserAttrSubPacket], [SignaturePayload])]
_tkSubs :: [(Pkt, SignaturePayload, Maybe SignaturePayload)]

Instances

Eq TK |
Data TK |
Ord TK |
Show TK |
Typeable TK |
Indexable TK |

type Keyring = IxSet TK Source

class Packet a where Source

Associated Types

data PacketType a :: *Source

Methods

packetType :: a -> PacketType aSource

packetCode :: PacketType a -> Word8 Source

toPkt :: a -> Pkt Source

fromPkt :: Pkt -> aSource

Instances

Packet BrokenPacket |
Packet OtherPacket |
Packet ModificationDetectionCode |
Packet SymEncIntegrityProtectedData |
Packet UserAttribute |
Packet PublicSubkey |
Packet UserId |
Packet Trust |
Packet LiteralData |
Packet Marker |
Packet SymEncData |
Packet CompressedData |
Packet SecretSubkey |
Packet PublicKey |
Packet SecretKey |
Packet OnePassSignature |
Packet SKESK |
Packet Signature |
Packet PKESK |

data Pkt Source

Constructors

PKESKPkt PacketVersion EightOctetKeyId PubKeyAlgorithm [MPI] |
SignaturePkt SignaturePayload |
SKESKPkt PacketVersion SymmetricAlgorithm S2K (Maybe ByteString) |
OnePassSignaturePkt PacketVersion SigType HashAlgorithm PubKeyAlgorithm EightOctetKeyId NestedFlag |
SecretKeyPkt PKPayload SKAddendum |
PublicKeyPkt PKPayload |
SecretSubkeyPkt PKPayload SKAddendum |
CompressedDataPkt CompressionAlgorithm CompressedDataPayload |
SymEncDataPkt ByteString |
MarkerPkt ByteString |
LiteralDataPkt DataType FileName TimeStamp ByteString |
TrustPkt ByteString |
UserIdPkt String |
PublicSubkeyPkt PKPayload |
UserAttributePkt [UserAttrSubPacket] |
SymEncIntegrityProtectedDataPkt PacketVersion ByteString |
ModificationDetectionCodePkt ByteString |
OtherPacketPkt Word8 ByteString |
BrokenPacketPkt String Word8 ByteString |

Instances

Eq Pkt |
Data Pkt |
Show Pkt |
Typeable Pkt |
Serialize Pkt |

pktTag :: Pkt -> Word8 Source

data PKESK Source

Constructors

PKESK |

Fields

_pkeskPacketVersion :: PacketVersion
_pkeskEightOctetKeyId :: EightOctetKeyId
_pkeskPubKeyAlgorithm :: PubKeyAlgorithm
_pkeskMPIs :: [MPI]

Instances

Eq PKESK |
Data PKESK |
Show PKESK |
Typeable PKESK |
Serialize PKESK |
Packet PKESK |
Eq (PacketType PKESK) |
Show (PacketType PKESK) |

data Signature Source

Constructors

Signature |

Fields

_signaturePayload :: SignaturePayload

Instances

Eq Signature |
Data Signature |
Show Signature |
Typeable Signature |
Serialize Signature |
Packet Signature |
Eq (PacketType Signature) |
Show (PacketType Signature) |

data SKESK Source

Constructors

SKESK |

Fields

_skeskPacketVersion :: PacketVersion
_skeskSymmetricAlgorithm :: SymmetricAlgorithm
_skeskS2K :: S2K
_skeskESK :: Maybe ByteString

Instances

Eq SKESK |
Data SKESK |
Show SKESK |
Typeable SKESK |
Serialize SKESK |
Packet SKESK |
Eq (PacketType SKESK) |
Show (PacketType SKESK) |

data OnePassSignature Source

Constructors

OnePassSignature |

Fields

_onePassSignaturePacketVersion :: PacketVersion
_onePassSignatureSigType :: SigType
_onePassSignatureHashAlgorithm :: HashAlgorithm
_onePassSignaturePubKeyAlgorithm :: PubKeyAlgorithm
_onePassSignatureEightOctetKeyId :: EightOctetKeyId
_onePassSignatureNestedFlag :: NestedFlag

Instances

Eq OnePassSignature |
Data OnePassSignature |
Show OnePassSignature |
Typeable OnePassSignature |
Serialize OnePassSignature |
Packet OnePassSignature |
Eq (PacketType OnePassSignature) |
Show (PacketType OnePassSignature) |

data SecretKey Source

Constructors

SecretKey |

Fields

_secretKeyPKPayload :: PKPayload
_secretKeySKAddendum :: SKAddendum

Instances

Eq SecretKey |
Data SecretKey |
Show SecretKey |
Typeable SecretKey |
Serialize SecretKey |
Packet SecretKey |
Eq (PacketType SecretKey) |
Show (PacketType SecretKey) |

data PublicKey Source

Constructors

PublicKey |

Fields

_publicKeyPKPayload :: PKPayload

Instances

Eq PublicKey |
Data PublicKey |
Show PublicKey |
Typeable PublicKey |
Serialize PublicKey |
Packet PublicKey |
Eq (PacketType PublicKey) |
Show (PacketType PublicKey) |

data SecretSubkey Source

Constructors

SecretSubkey |

Fields

_secretSubkeyPKPayload :: PKPayload
_secretSubkeySKAddendum :: SKAddendum

Instances

Eq SecretSubkey |
Data SecretSubkey |
Show SecretSubkey |
Typeable SecretSubkey |
Serialize SecretSubkey |
Packet SecretSubkey |
Eq (PacketType SecretSubkey) |
Show (PacketType SecretSubkey) |

data CompressedData Source

Constructors

CompressedData |

Fields

_compressedDataCompressionAlgorithm :: CompressionAlgorithm
_compressedDataPayload :: CompressedDataPayload

Instances

Eq CompressedData |
Data CompressedData |
Show CompressedData |
Typeable CompressedData |
Serialize CompressedData |
Packet CompressedData |
Eq (PacketType CompressedData) |
Show (PacketType CompressedData) |

data SymEncData Source

Constructors

SymEncData |

Fields

_symEncDataPayload :: ByteString

Instances

Eq SymEncData |
Data SymEncData |
Show SymEncData |
Typeable SymEncData |
Serialize SymEncData |
Packet SymEncData |
Eq (PacketType SymEncData) |
Show (PacketType SymEncData) |

data Marker Source

Constructors

Marker |

Fields

_markerPayload :: ByteString

Instances

Eq Marker |
Data Marker |
Show Marker |
Typeable Marker |
Serialize Marker |
Packet Marker |
Eq (PacketType Marker) |
Show (PacketType Marker) |

data LiteralData Source

Constructors

LiteralData |

Fields

_literalDataDataType :: DataType
_literalDataFileName :: FileName
_literalDataTimeStamp :: TimeStamp
_literalDataPayload :: ByteString

Instances

Eq LiteralData |
Data LiteralData |
Show LiteralData |
Typeable LiteralData |
Serialize LiteralData |
Packet LiteralData |
Eq (PacketType LiteralData) |
Show (PacketType LiteralData) |

data Trust Source

Constructors

Trust |

Fields

_trustPayload :: ByteString

Instances

Eq Trust |
Data Trust |
Show Trust |
Typeable Trust |
Serialize Trust |
Packet Trust |
Eq (PacketType Trust) |
Show (PacketType Trust) |

data UserId Source

Constructors

UserId |

Fields

_userIdPayload :: String

Instances

Eq UserId |
Data UserId |
Show UserId |
Typeable UserId |
Serialize UserId |
Packet UserId |
Eq (PacketType UserId) |
Show (PacketType UserId) |

data PublicSubkey Source

Constructors

PublicSubkey |

Fields

_publicSubkeyPKPayload :: PKPayload

Instances

Eq PublicSubkey |
Data PublicSubkey |
Show PublicSubkey |
Typeable PublicSubkey |
Serialize PublicSubkey |
Packet PublicSubkey |
Eq (PacketType PublicSubkey) |
Show (PacketType PublicSubkey) |

data UserAttribute Source

Constructors

UserAttribute |

Fields

_userAttributeSubPackets :: [UserAttrSubPacket]

Instances

Eq UserAttribute |
Data UserAttribute |
Show UserAttribute |
Typeable UserAttribute |
Serialize UserAttribute |
Packet UserAttribute |
Eq (PacketType UserAttribute) |
Show (PacketType UserAttribute) |

data SymEncIntegrityProtectedData Source

Constructors

SymEncIntegrityProtectedData |

Fields

_symEncIntegrityProtectedDataPacketVersion :: PacketVersion
_symEncIntegrityProtectedDataPayload :: ByteString

Instances

Eq SymEncIntegrityProtectedData |
Data SymEncIntegrityProtectedData |
Show SymEncIntegrityProtectedData |
Typeable SymEncIntegrityProtectedData |
Serialize SymEncIntegrityProtectedData |
Packet SymEncIntegrityProtectedData |
Eq (PacketType SymEncIntegrityProtectedData) |
Show (PacketType SymEncIntegrityProtectedData) |

data ModificationDetectionCode Source

Constructors

ModificationDetectionCode |

Fields

_modificationDetectionCodePayload :: ByteString

Instances

Eq ModificationDetectionCode |
Data ModificationDetectionCode |
Show ModificationDetectionCode |
Typeable ModificationDetectionCode |
Serialize ModificationDetectionCode |
Packet ModificationDetectionCode |
Eq (PacketType ModificationDetectionCode) |
Show (PacketType ModificationDetectionCode) |

data OtherPacket Source

Constructors

OtherPacket |

Fields

_otherPacketType :: Word8
_otherPacketPayload :: ByteString

Instances

Eq OtherPacket |
Data OtherPacket |
Show OtherPacket |
Typeable OtherPacket |
Serialize OtherPacket |
Packet OtherPacket |
Eq (PacketType OtherPacket) |
Show (PacketType OtherPacket) |

data BrokenPacket Source

Constructors

BrokenPacket |

Fields

_brokenPacketParseError :: String
_brokenPacketType :: Word8
_brokenPacketPayload :: ByteString

Instances

Eq BrokenPacket |
Data BrokenPacket |
Show BrokenPacket |
Typeable BrokenPacket |
Packet BrokenPacket |
Eq (PacketType BrokenPacket) |
Show (PacketType BrokenPacket) |

data Verification Source

Constructors

Verification |

Fields

_verificationSigner :: PKPayload
_verificationSignature :: SignaturePayload

pkeskPubKeyAlgorithm :: Lens' PKESK PubKeyAlgorithm Source

pkeskPacketVersion :: Lens' PKESK PacketVersion Source

pkeskMPIs :: Lens' PKESK [MPI]Source

pkeskEightOctetKeyId :: Lens' PKESK EightOctetKeyId Source

signaturePayload :: Iso' Signature SignaturePayload Source

skeskSymmetricAlgorithm :: Lens' SKESK SymmetricAlgorithm Source

skeskS2K :: Lens' SKESK S2K Source

skeskPacketVersion :: Lens' SKESK PacketVersion Source

skeskESK :: Lens' SKESK (Maybe ByteString)Source

onePassSignatureSigType :: Lens' OnePassSignature SigType Source

onePassSignaturePubKeyAlgorithm :: Lens' OnePassSignature PubKeyAlgorithm Source

onePassSignaturePacketVersion :: Lens' OnePassSignature PacketVersion Source

onePassSignatureNestedFlag :: Lens' OnePassSignature NestedFlag Source

onePassSignatureHashAlgorithm :: Lens' OnePassSignature HashAlgorithm Source

onePassSignatureEightOctetKeyId :: Lens' OnePassSignature EightOctetKeyId Source

secretKeySKAddendum :: Lens' SecretKey SKAddendum Source

secretKeyPKPayload :: Lens' SecretKey PKPayload Source

v3exp :: Lens' PKPayload V3Expiration Source

timestamp :: Lens' PKPayload TimeStamp Source

pubkey :: Lens' PKPayload PKey Source

pkalgo :: Lens' PKPayload PubKeyAlgorithm Source

keyVersion :: Lens' PKPayload KeyVersion Source

publicKeyPKPayload :: Iso' PublicKey PKPayload Source

secretSubkeySKAddendum :: Lens' SecretSubkey SKAddendum Source

secretSubkeyPKPayload :: Lens' SecretSubkey PKPayload Source

compressedDataPayload :: Lens' CompressedData CompressedDataPayload Source

compressedDataCompressionAlgorithm :: Lens' CompressedData CompressionAlgorithm Source

symEncDataPayload :: Iso' SymEncData ByteString Source

markerPayload :: Iso' Marker ByteString Source

literalDataTimeStamp :: Lens' LiteralData TimeStamp Source

literalDataPayload :: Lens' LiteralData ByteString Source

literalDataFileName :: Lens' LiteralData FileName Source

literalDataDataType :: Lens' LiteralData DataType Source

trustPayload :: Iso' Trust ByteString Source

userIdPayload :: Iso' UserId String Source

publicSubkeyPKPayload :: Iso' PublicSubkey PKPayload Source

userAttributeSubPackets :: Iso' UserAttribute [UserAttrSubPacket]Source

symEncIntegrityProtectedDataPayload :: Lens' SymEncIntegrityProtectedData ByteString Source

symEncIntegrityProtectedDataPacketVersion :: Lens' SymEncIntegrityProtectedData PacketVersion Source

modificationDetectionCodePayload :: Iso' ModificationDetectionCode ByteString Source

otherPacketType :: Lens' OtherPacket Word8 Source

otherPacketPayload :: Lens' OtherPacket ByteString Source

tkmSKA :: Lens' TK (Maybe SKAddendum)Source

tkUIDs :: Lens' TK [(String, [SignaturePayload])]Source

tkUAts :: Lens' TK [([UserAttrSubPacket], [SignaturePayload])]Source

tkSubs :: Lens' TK [(Pkt, SignaturePayload, Maybe SignaturePayload)]Source

tkRevs :: Lens' TK [SignaturePayload]Source

tkPKP :: Lens' TK PKPayload Source

verificationSigner :: Lens' Verification PKPayload Source

verificationSignature :: Lens' Verification SignaturePayload Source

sspPayload :: Lens' SigSubPacket SigSubPacketPayload Source

sspCriticality :: Lens' SigSubPacket Bool Source